--- //depot/vendor/freebsd/src/sys/kern/uipc_usrreq.c	2004/02/29 19:15:33
+++ //depot/user/rwatson/netperf/sys/kern/uipc_usrreq.c	2004/02/29 21:00:26
@@ -85,6 +85,39 @@
 static struct	sockaddr sun_noname = { sizeof(sun_noname), AF_LOCAL };
 static ino_t	unp_ino;		/* prototype for fake inode numbers */
 
+static struct mtx unp_mtx;
+#define	UNP_HEAD_LOCK_INIT() \
+	mtx_init(&unp_mtx, "unp head", NULL, MTX_DEF)
+#define	UNP_HEAD_LOCK()			mtx_lock(&unp_mtx)
+#define	UNP_HEAD_UNLOCK()		mtx_unlock(&unp_mtx)
+#define	UNP_HEAD_LOCK_ASSERT()		mtx_assert(&unp_mtx, MA_OWNED)
+
+/* NB: DUPOK is to cover the connect2 case XXX */
+#define	UNP_LOCK_INIT(_unp) \
+	mtx_init(&(_unp)->unp_mtx, "unp", NULL, MTX_DEF | MTX_DUPOK)
+#define	UNP_LOCK_DESTROY(_unp)		mtx_destroy(&(_unp)->unp_mtx)
+#define	UNP_LOCK(_unp)			mtx_lock(&(_unp)->unp_mtx)
+#define	UNP_UNLOCK(_unp)		mtx_unlock(&(_unp)->unp_mtx)
+#define	UNP_LOCK_ASSERT(_unp)		mtx_assert(&(_unp)->unp_mtx, MA_OWNED)
+
+/*
+ * A unp lock is always preceded by locking the head.
+ * Since this occurs often we define convenienc macros
+ * for entry, exist, and validation in lower-level routines.
+ */
+#define	UNP_ENTER(_unp) do {		\
+	UNP_HEAD_LOCK();		\
+	UNP_LOCK(_unp);			\
+} while (0)
+#define	UNP_EXIT(_unp) do {		\
+	UNP_UNLOCK(_unp);		\
+	UNP_HEAD_UNLOCK();		\
+} while (0)
+#define	UNP_ASSERT(_unp) do {		\
+	UNP_HEAD_LOCK_ASSERT();		\
+	UNP_LOCK_ASSERT(_unp);		\
+} while (0)
+
 static int     unp_attach(struct socket *);
 static void    unp_detach(struct unpcb *);
 static int     unp_bind(struct unpcb *,struct sockaddr *, struct thread *);
@@ -107,8 +140,10 @@
 
 	if (unp == 0)
 		return (EINVAL);
+	UNP_ENTER(unp);
 	unp_drop(unp, ECONNABORTED);
-	unp_detach(unp);
+	unp_detach(unp);	/* NB: unlocks unp + head */
+	SOCK_LOCK(so);
 	sotryfree(so);
 	return (0);
 }
@@ -117,6 +152,7 @@
 uipc_accept(struct socket *so, struct sockaddr **nam)
 {
 	struct unpcb *unp = sotounpcb(so);
+	struct sockaddr *sa;
 
 	if (unp == 0)
 		return (EINVAL);
@@ -126,13 +162,14 @@
 	 * if it was bound and we are still connected
 	 * (our peer may have closed already!).
 	 */
-	if (unp->unp_conn && unp->unp_conn->unp_addr) {
-		*nam = sodupsockaddr(
-		    (struct sockaddr *)unp->unp_conn->unp_addr, M_WAITOK);
-	} else {
-		*nam = sodupsockaddr((struct sockaddr *)&sun_noname,
-		    M_WAITOK);
-	}
+	*nam = malloc(sizeof(struct sockaddr_un), M_SONAME, M_WAITOK);
+	UNP_ENTER(unp);
+	if (unp->unp_conn && unp->unp_conn->unp_addr)
+		sa = (struct sockaddr *) unp->unp_conn->unp_addr;
+	else
+		sa = &sun_noname;
+	bcopy(sa, *nam, sa->sa_len);
+	UNP_EXIT(unp);
 	return (0);
 }
 
@@ -153,7 +190,6 @@
 
 	if (unp == 0)
 		return (EINVAL);
-
 	return (unp_bind(unp, nam, td));
 }
 
@@ -161,21 +197,30 @@
 uipc_connect(struct socket *so, struct sockaddr *nam, struct thread *td)
 {
 	struct unpcb *unp = sotounpcb(so);
+	int retval;
 
-	if (unp == 0)
-		return (EINVAL);
-	return (unp_connect(so, nam, curthread));
+	if (unp != 0) {
+		UNP_ENTER(unp);
+		retval = unp_connect(so, nam, curthread);
+		UNP_EXIT(unp);
+	} else
+		retval = EINVAL;
+	return (retval);
 }
 
 static int
 uipc_connect2(struct socket *so1, struct socket *so2)
 {
 	struct unpcb *unp = sotounpcb(so1);
+	int retval;
 
-	if (unp == 0)
-		return (EINVAL);
-
-	return (unp_connect2(so1, so2));
+	if (unp != 0) {
+		UNP_ENTER(unp);
+		retval = unp_connect2(so1, so2);
+		UNP_EXIT(unp);
+	} else
+		retval = EINVAL;
+	return (retval);
 }
 
 /* control is EOPNOTSUPP */
@@ -187,8 +232,8 @@
 
 	if (unp == 0)
 		return (EINVAL);
-
-	unp_detach(unp);
+	UNP_ENTER(unp);
+	unp_detach(unp);	/* NB: unlocks unp + head */
 	return (0);
 }
 
@@ -197,41 +242,52 @@
 {
 	struct unpcb *unp = sotounpcb(so);
 
-	if (unp == 0)
+	if (unp != 0) {
+		UNP_ENTER(unp);
+		unp_disconnect(unp);
+		UNP_EXIT(unp);
+		return (0);
+	} else
 		return (EINVAL);
-	unp_disconnect(unp);
-	return (0);
 }
 
 static int
 uipc_listen(struct socket *so, struct thread *td)
 {
 	struct unpcb *unp = sotounpcb(so);
+	int retval;
 
-	if (unp == 0 || unp->unp_vnode == 0)
+	if (unp != 0 && unp->unp_vnode != 0) {
+		UNP_ENTER(unp);
+		retval = unp_listen(unp, td);
+		UNP_EXIT(unp);
+	} else
 		return (EINVAL);
-	return (unp_listen(unp, td));
+	return (retval);
 }
 
 static int
 uipc_peeraddr(struct socket *so, struct sockaddr **nam)
 {
 	struct unpcb *unp = sotounpcb(so);
+	struct sockaddr *sa;
 
 	if (unp == 0)
 		return (EINVAL);
+	*nam = malloc(sizeof(struct sockaddr_un), M_SONAME, M_WAITOK);
+	UNP_ENTER(unp);
 	if (unp->unp_conn && unp->unp_conn->unp_addr)
-		*nam = sodupsockaddr(
-		    (struct sockaddr *)unp->unp_conn->unp_addr, M_WAITOK);
+		sa = (struct sockaddr *) unp->unp_conn->unp_addr;
 	else {
 		/*
 		 * XXX: It seems that this test always fails even when
 		 * connection is established.  So, this else clause is
 		 * added as workaround to return PF_LOCAL sockaddr.
 		 */
-		*nam = sodupsockaddr((struct sockaddr *)&sun_noname,
-		    M_WAITOK);
+		sa = &sun_noname;
 	}
+	bcopy(sa, *nam, sa->sa_len);
+	UNP_EXIT(unp);
 	return (0);
 }
 
@@ -244,15 +300,27 @@
 
 	if (unp == 0)
 		return (EINVAL);
+	/*
+	 * Reorder locks to avoid LORs.  Note that we
+	 * delay re-locking so_rcv to below so it can
+	 * be done only once.
+	 */
+	SOCKBUF_UNLOCK(&so->so_rcv);
+	UNP_ENTER(unp);
 	switch (so->so_type) {
 	case SOCK_DGRAM:
 		panic("uipc_rcvd DGRAM?");
 		/*NOTREACHED*/
 
 	case SOCK_STREAM:
-		if (unp->unp_conn == 0)
+		if (unp->unp_conn == 0) {
+			SOCKBUF_LOCK(&so->so_rcv);
 			break;
+		}
 		so2 = unp->unp_conn->unp_socket;
+		/* NB: careful of order here */
+		SOCKBUF_LOCK(&so2->so_snd);
+		SOCKBUF_LOCK(&so->so_rcv);
 		/*
 		 * Adjust backpressure on sender
 		 * and wakeup any waiting to write.
@@ -264,12 +332,14 @@
 		(void)chgsbsize(so2->so_cred->cr_uidinfo, &so2->so_snd.sb_hiwat,
 		    newhiwat, RLIM_INFINITY);
 		unp->unp_cc = so->so_rcv.sb_cc;
-		sowwakeup(so2);
+		sowwakeup_locked(so2);
+		SOCKBUF_UNLOCK(&so2->so_snd);
 		break;
 
 	default:
 		panic("uipc_rcvd unknown socktype");
 	}
+	UNP_EXIT(unp);
 	return (0);
 }
 
@@ -296,6 +366,13 @@
 	if (control && (error = unp_internalize(&control, td)))
 		goto release;
 
+	/*
+	 * Reorder locks to avoid LORs.
+	 */
+	SOCKBUF_UNLOCK(&so->so_snd);
+	UNP_ENTER(unp);
+	SOCKBUF_LOCK(&so->so_snd);
+
 	switch (so->so_type) {
 	case SOCK_DGRAM:
 	{
@@ -306,7 +383,9 @@
 				error = EISCONN;
 				break;
 			}
+			SOCKBUF_UNLOCK(&so->so_snd);
 			error = unp_connect(so, nam, td);
+			SOCKBUF_LOCK(&so->so_snd);
 			if (error)
 				break;
 		} else {
@@ -320,13 +399,14 @@
 			from = (struct sockaddr *)unp->unp_addr;
 		else
 			from = &sun_noname;
-		if (sbappendaddr(&so2->so_rcv, from, m, control)) {
-			sorwakeup(so2);
+		SOCKBUF_LOCK(&so2->so_rcv);
+		if (sbappendaddr_locked(&so2->so_rcv, from, m, control)) {
+			sorwakeup_locked(so2);
 			m = 0;
 			control = 0;
-		} else {
+		} else
 			error = ENOBUFS;
-		}
+		SOCKBUF_UNLOCK(&so2->so_rcv);
 		if (nam)
 			unp_disconnect(unp);
 		break;
@@ -340,7 +420,9 @@
 		 */
 		if ((so->so_state & SS_ISCONNECTED) == 0) {
 			if (nam) {
+				SOCKBUF_UNLOCK(&so->so_snd);
 				error = unp_connect(so, nam, td);
+				SOCKBUF_LOCK(&so->so_snd);
 				if (error)
 					break;	/* XXX */
 			} else {
@@ -356,17 +438,17 @@
 		if (unp->unp_conn == 0)
 			panic("uipc_send connected but no connection?");
 		so2 = unp->unp_conn->unp_socket;
+		SOCKBUF_LOCK(&so2->so_rcv);
 		/*
 		 * Send to paired receive port, and then reduce
 		 * send buffer hiwater marks to maintain backpressure.
 		 * Wake up readers.
 		 */
 		if (control) {
-			if (sbappendcontrol(&so2->so_rcv, m, control))
+			if (sbappendcontrol_locked(&so2->so_rcv, m, control))
 				control = 0;
-		} else {
-			sbappend(&so2->so_rcv, m);
-		}
+		} else
+			sbappend_locked(&so2->so_rcv, m);
 		so->so_snd.sb_mbmax -=
 			so2->so_rcv.sb_mbcnt - unp->unp_conn->unp_mbcnt;
 		unp->unp_conn->unp_mbcnt = so2->so_rcv.sb_mbcnt;
@@ -375,7 +457,8 @@
 		(void)chgsbsize(so->so_cred->cr_uidinfo, &so->so_snd.sb_hiwat,
 		    newhiwat, RLIM_INFINITY);
 		unp->unp_conn->unp_cc = so2->so_rcv.sb_cc;
-		sorwakeup(so2);
+		sorwakeup_locked(so2);
+		SOCKBUF_UNLOCK(&so2->so_rcv);
 		m = 0;
 		break;
 
@@ -388,13 +471,13 @@
 	 * a SHUTDOWN.
 	 */
 	if (flags & PRUS_EOF) {
-		socantsendmore(so);
+		socantsendmore_locked(so);
 		unp_shutdown(unp);
 	}
+	UNP_EXIT(unp);
 
 	if (control && error != 0)
-		unp_dispose(control);
-
+		unp_dispose(control);		/* XXX need head lock? */
 release:
 	if (control)
 		m_freem(control);
@@ -411,6 +494,7 @@
 
 	if (unp == 0)
 		return (EINVAL);
+	UNP_ENTER(unp);
 	sb->st_blksize = so->so_snd.sb_hiwat;
 	if (so->so_type == SOCK_STREAM && unp->unp_conn != 0) {
 		so2 = unp->unp_conn->unp_socket;
@@ -420,6 +504,7 @@
 	if (unp->unp_ino == 0)
 		unp->unp_ino = (++unp_ino == 0) ? ++unp_ino : unp_ino;
 	sb->st_ino = unp->unp_ino;
+	UNP_EXIT(unp);
 	return (0);
 }
 
@@ -430,8 +515,11 @@
 
 	if (unp == 0)
 		return (EINVAL);
+	UNP_ENTER(unp);
+	/* XXX socket lock? */
 	socantsendmore(so);
 	unp_shutdown(unp);
+	UNP_EXIT(unp);
 	return (0);
 }
 
@@ -439,15 +527,18 @@
 uipc_sockaddr(struct socket *so, struct sockaddr **nam)
 {
 	struct unpcb *unp = sotounpcb(so);
+	struct sockaddr *sa;
 
 	if (unp == 0)
 		return (EINVAL);
+	*nam = malloc(sizeof(struct sockaddr_un), M_SONAME, M_WAITOK);
+	UNP_ENTER(unp);
 	if (unp->unp_addr)
-		*nam = sodupsockaddr((struct sockaddr *)unp->unp_addr,
-		    M_WAITOK);
+		sa = (struct sockaddr *) unp->unp_addr;
 	else
-		*nam = sodupsockaddr((struct sockaddr *)&sun_noname,
-		    M_WAITOK);
+		sa = &sun_noname;
+	bcopy(sa, *nam, sa->sa_len);
+	UNP_EXIT(unp);
 	return (0);
 }
 
@@ -469,6 +560,7 @@
 
 	switch (sopt->sopt_dir) {
 	case SOPT_GET:
+		UNP_ENTER(unp);
 		switch (sopt->sopt_name) {
 		case LOCAL_PEERCRED:
 			if (unp->unp_flags & UNP_HAVEPC)
@@ -485,6 +577,7 @@
 			error = EOPNOTSUPP;
 			break;
 		}
+		UNP_EXIT(unp);
 		break;
 	case SOPT_SET:
 	default:
@@ -557,8 +650,13 @@
 	unp_count++;
 	LIST_INIT(&unp->unp_refs);
 	unp->unp_socket = so;
+	UNP_LOCK_INIT(unp);
+
+	UNP_HEAD_LOCK();
 	LIST_INSERT_HEAD(so->so_type == SOCK_DGRAM ? &unp_dhead
 			 : &unp_shead, unp, unp_link);
+	UNP_HEAD_UNLOCK();
+
 	so->so_pcb = unp;
 	return (0);
 }
@@ -567,18 +665,25 @@
 unp_detach(unp)
 	register struct unpcb *unp;
 {
+	struct vnode *vp;
+
+	UNP_ASSERT(unp);
+
 	LIST_REMOVE(unp, unp_link);
 	unp->unp_gencnt = ++unp_gencnt;
 	--unp_count;
-	if (unp->unp_vnode) {
+	if ((vp = unp->unp_vnode)) {
 		unp->unp_vnode->v_socket = 0;
-		vrele(unp->unp_vnode);
 		unp->unp_vnode = 0;
 	}
 	if (unp->unp_conn)
 		unp_disconnect(unp);
-	while (!LIST_EMPTY(&unp->unp_refs))
-		unp_drop(LIST_FIRST(&unp->unp_refs), ECONNRESET);
+	while (!LIST_EMPTY(&unp->unp_refs)) {
+		struct unpcb *ref = LIST_FIRST(&unp->unp_refs);
+		UNP_LOCK(ref);
+		unp_drop(ref, ECONNRESET);
+		UNP_UNLOCK(ref);
+	}
 	soisdisconnected(unp->unp_socket);
 	unp->unp_socket->so_pcb = 0;
 	if (unp_rights) {
@@ -594,7 +699,11 @@
 	}
 	if (unp->unp_addr)
 		FREE(unp->unp_addr, M_SONAME);
+	UNP_LOCK_DESTROY(unp);
+	UNP_HEAD_UNLOCK();
 	uma_zfree(unp_zone, unp);
+	if (vp)
+		vrele(vp);
 }
 
 static int
@@ -621,15 +730,14 @@
 	buf = malloc(namelen + 1, M_TEMP, M_WAITOK);
 	strlcpy(buf, soun->sun_path, namelen + 1);
 
+	mtx_lock(&Giant);
 restart:
 	NDINIT(&nd, CREATE, NOFOLLOW | LOCKPARENT | SAVENAME, UIO_SYSSPACE,
 	    buf, td);
 /* SHOULD BE ABLE TO ADOPT EXISTING AND wakeup() ALA FIFO's */
 	error = namei(&nd);
-	if (error) {
-		free(buf, M_TEMP);
-		return (error);
-	}
+	if (error)
+		goto done;
 	vp = nd.ni_vp;
 	if (vp != NULL || vn_start_write(nd.ni_dvp, &mp, V_NOWAIT) != 0) {
 		NDFREE(&nd, NDF_ONLY_PNBUF);
@@ -639,14 +747,12 @@
 			vput(nd.ni_dvp);
 		if (vp != NULL) {
 			vrele(vp);
-			free(buf, M_TEMP);
-			return (EADDRINUSE);
+			error = EADDRINUSE;
+			goto done;
 		}
 		error = vn_start_write(NULL, &mp, V_XSLEEP | PCATCH);
-		if (error) {
-			free(buf, M_TEMP);
-			return (error);
-		}
+		if (error)
+			goto done;
 		goto restart;
 	}
 	VATTR_NULL(&vattr);
@@ -662,18 +768,21 @@
 	}
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	vput(nd.ni_dvp);
-	if (error) {
-		free(buf, M_TEMP);
-		return (error);
-	}
+	if (error)
+		goto done;
 	vp = nd.ni_vp;
+	soun = (struct sockaddr_un *)sodupsockaddr(nam, M_WAITOK);
+	UNP_ENTER(unp);
 	vp->v_socket = unp->unp_socket;
 	unp->unp_vnode = vp;
-	unp->unp_addr = (struct sockaddr_un *)sodupsockaddr(nam, M_WAITOK);
+	unp->unp_addr = soun;
+	UNP_EXIT(unp);
 	VOP_UNLOCK(vp, 0, td);
 	vn_finished_write(mp);
+done:
+	mtx_unlock(&Giant);
 	free(buf, M_TEMP);
-	return (0);
+	return (error);
 }
 
 static int
@@ -685,10 +794,14 @@
 	register struct sockaddr_un *soun = (struct sockaddr_un *)nam;
 	register struct vnode *vp;
 	register struct socket *so2, *so3;
-	struct unpcb *unp, *unp2, *unp3;
+	struct unpcb *unp = sotounpcb(so);
+	struct unpcb *unp2, *unp3;
 	int error, len;
 	struct nameidata nd;
 	char buf[SOCK_MAXADDRLEN];
+	struct sockaddr *sa;
+
+	UNP_ASSERT(unp);
 
 	len = nam->sa_len - offsetof(struct sockaddr_un, sun_path);
 	if (len <= 0)
@@ -696,9 +809,17 @@
 	strlcpy(buf, soun->sun_path, len + 1);
 
 	NDINIT(&nd, LOOKUP, FOLLOW | LOCKLEAF, UIO_SYSSPACE, buf, td);
+	/* drop locks across namei */
+	UNP_EXIT(unp);
+	mtx_lock(&Giant);
 	error = namei(&nd);
+	if (!error)
+		sa = malloc(sizeof(struct sockaddr_un), M_SONAME, M_WAITOK);
+	else
+		sa = NULL;
+	UNP_ENTER(unp);
 	if (error)
-		return (error);
+		goto bad2;
 	vp = nd.ni_vp;
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	if (vp->v_type != VSOCK) {
@@ -718,19 +839,30 @@
 		goto bad;
 	}
 	if (so->so_proto->pr_flags & PR_CONNREQUIRED) {
-		if ((so2->so_options & SO_ACCEPTCONN) == 0 ||
-		    (so3 = sonewconn(so2, 0)) == 0) {
+		if (so2->so_options & SO_ACCEPTCONN) {
+			/*
+			 * NB: drop locks here so unp_attach is entered
+			 *     w/o locks; this avoids a recursive lock
+			 *     of the head and holding sleep locks across
+			 *     a (potentially) blocking malloc.
+			 */
+			UNP_EXIT(unp);
+			so3 = sonewconn(so2, 0);
+			UNP_ENTER(unp);
+		} else
+			so3 = 0;
+		if (so3 == 0) {
 			error = ECONNREFUSED;
 			goto bad;
 		}
 		unp = sotounpcb(so);
 		unp2 = sotounpcb(so2);
 		unp3 = sotounpcb(so3);
-		if (unp2->unp_addr)
-			unp3->unp_addr = (struct sockaddr_un *)
-			    sodupsockaddr((struct sockaddr *)unp2->unp_addr,
-			    M_WAITOK);
-
+		if (unp2->unp_addr) {
+			bcopy(unp2->unp_addr, sa, unp2->unp_addr->sun_len);
+			unp3->unp_addr = (struct sockaddr_un *) sa;
+			sa = NULL;
+		}
 		/*
 		 * unp_peercred management:
 		 *
@@ -762,6 +894,10 @@
 	error = unp_connect2(so, so2);
 bad:
 	vput(vp);
+bad2:
+	if (sa)
+		free(sa, M_SONAME);
+	mtx_unlock(&Giant);
 	return (error);
 }
 
@@ -773,9 +909,12 @@
 	register struct unpcb *unp = sotounpcb(so);
 	register struct unpcb *unp2;
 
+	UNP_ASSERT(unp);
+
 	if (so2->so_type != so->so_type)
 		return (EPROTOTYPE);
 	unp2 = sotounpcb(so2);
+	UNP_LOCK(unp2);
 	unp->unp_conn = unp2;
 	switch (so->so_type) {
 
@@ -793,6 +932,7 @@
 	default:
 		panic("unp_connect2");
 	}
+	UNP_UNLOCK(unp2);
 	return (0);
 }
 
@@ -802,6 +942,8 @@
 {
 	register struct unpcb *unp2 = unp->unp_conn;
 
+	UNP_ASSERT(unp);
+
 	if (unp2 == 0)
 		return;
 	unp->unp_conn = 0;
@@ -814,10 +956,13 @@
 
 	case SOCK_STREAM:
 		soisdisconnected(unp->unp_socket);
+		UNP_LOCK(unp2);
 		unp2->unp_conn = 0;
 		soisdisconnected(unp2->unp_socket);
+		UNP_UNLOCK(unp2);
 		break;
 	}
+	return;
 }
 
 #ifdef notdef
@@ -860,8 +1005,10 @@
 	 * OK, now we're committed to doing something.
 	 */
 	xug = malloc(sizeof(*xug), M_TEMP, M_WAITOK);
+	UNP_HEAD_LOCK();
 	gencnt = unp_gencnt;
 	n = unp_count;
+	UNP_HEAD_UNLOCK();
 
 	xug->xug_len = sizeof *xug;
 	xug->xug_count = n;
@@ -875,6 +1022,7 @@
 
 	unp_list = malloc(n * sizeof *unp_list, M_TEMP, M_WAITOK);
 
+	UNP_HEAD_LOCK();
 	for (unp = LIST_FIRST(head), i = 0; unp && i < n;
 	     unp = LIST_NEXT(unp, unp_link)) {
 		if (unp->unp_gencnt <= gencnt) {
@@ -884,6 +1032,7 @@
 			unp_list[i++] = unp;
 		}
 	}
+	UNP_HEAD_UNLOCK();
 	n = i;			/* in case we lost some during malloc */
 
 	error = 0;
@@ -941,6 +1090,8 @@
 {
 	struct socket *so;
 
+	UNP_ASSERT(unp);
+
 	if (unp->unp_socket->so_type == SOCK_STREAM && unp->unp_conn &&
 	    (so = unp->unp_conn->unp_socket))
 		socantrcvmore(so);
@@ -953,6 +1104,8 @@
 {
 	struct socket *so = unp->unp_socket;
 
+	UNP_ASSERT(unp);
+
 	so->so_error = errno;
 	unp_disconnect(unp);
 }
@@ -1104,6 +1257,8 @@
 	uma_zone_set_max(unp_zone, nmbclusters);
 	LIST_INIT(&unp_dhead);
 	LIST_INIT(&unp_shead);
+
+	UNP_HEAD_LOCK_INIT();
 }
 
 static int
@@ -1260,6 +1415,8 @@
 	struct file **extra_ref, **fpp;
 	int nunref, i;
 
+	UNP_HEAD_LOCK_ASSERT();		/* NB: this serializes entry */
+
 	if (unp_gcing)
 		return;
 	unp_gcing = 1;
@@ -1454,6 +1611,7 @@
 	struct unpcb *unp;
 	struct thread *td;
 {
+	UNP_ASSERT(unp);
 
 	cru2x(td->td_ucred, &unp->unp_peercred);
 	unp->unp_flags |= UNP_HAVEPCCACHED;
--- //depot/vendor/freebsd/src/sys/net/bpf.c	2004/02/29 07:35:30
+++ //depot/user/rwatson/netperf/sys/net/bpf.c	2004/03/01 16:13:52
@@ -557,7 +557,7 @@
 	struct ifnet *ifp;
 	struct mbuf *m;
 	int error;
-	static struct sockaddr dst;
+	struct sockaddr dst;
 	int datlen;
 
 	if (d->bd_bif == 0)
@@ -568,6 +568,7 @@
 	if (uio->uio_resid == 0)
 		return (0);
 
+	bzero(&dst, sizeof(dst));
 	error = bpf_movein(uio, (int)d->bd_bif->bif_dlt, &m, &dst, &datlen);
 	if (error)
 		return (error);
@@ -583,12 +584,10 @@
 	mac_create_mbuf_from_bpfdesc(d, m);
 	BPFD_UNLOCK(d);
 #endif
-	mtx_lock(&Giant);
+	/* NB: the driver frees the mbuf */
+	NET_LOCK_GIANT();
 	error = (*ifp->if_output)(ifp, m, &dst, (struct rtentry *)0);
-	mtx_unlock(&Giant);
-	/*
-	 * The driver frees the mbuf.
-	 */
+	NET_UNLOCK_GIANT();
 	return (error);
 }
 
--- //depot/vendor/freebsd/src/sys/net/bpfdesc.h	2004/02/29 07:35:30
+++ //depot/user/rwatson/netperf/sys/net/bpfdesc.h	2004/02/29 22:51:24
@@ -102,7 +102,10 @@
 
 #define BPFD_LOCK(bd)		mtx_lock(&(bd)->bd_mtx)
 #define BPFD_UNLOCK(bd)		mtx_unlock(&(bd)->bd_mtx)
-#define BPFD_LOCK_ASSERT(bd)	mtx_assert(&(bd)->bd_mtx, MA_OWNED)
+#define BPFD_LOCK_ASSERT(bd)	do {					\
+	mtx_assert(&(bd)->bd_mtx, MA_OWNED);				\
+	NET_ASSERT_GIANT();						\
+} while (0)
 
 /* Test whether a BPF is ready for read(). */
 #define	bpf_ready(bd)						 \
--- //depot/vendor/freebsd/src/sys/net/if.c	2004/03/12 18:35:54
+++ //depot/user/rwatson/netperf/sys/net/if.c	2004/03/12 22:29:12
@@ -659,6 +659,7 @@
 
 /*
  * Create a clone network interface.
+ * XXXRW: Locking?
  */
 int
 if_clone_create(char *name, int len)
@@ -731,6 +732,7 @@
 
 /*
  * Destroy a clone network interface.
+ * XXXRW: Locking?
  */
 int
 if_clone_destroy(const char *name)
@@ -768,6 +770,7 @@
 
 /*
  * Look up a network interface cloner.
+ * XXXRW: Locking?
  */
 static struct if_clone *
 if_clone_lookup(const char *name, int *unitp)
@@ -809,6 +812,7 @@
 
 /*
  * Register a network interface cloner.
+ * XXXRW: Locking?
  */
 void
 if_clone_attach(struct if_clone *ifc)
@@ -851,6 +855,7 @@
 
 /*
  * Unregister a network interface cloner.
+ * XXXRW: Locking?
  */
 void
 if_clone_detach(struct if_clone *ifc)
@@ -863,6 +868,7 @@
 
 /*
  * Provide list of interface cloners to userspace.
+ * XXXRW: Locking?
  */
 static int
 if_clone_list(struct if_clonereq *ifcr)
--- //depot/vendor/freebsd/src/sys/net/if_gif.c	2003/12/27 20:00:55
+++ //depot/user/rwatson/netperf/sys/net/if_gif.c	2004/03/09 15:48:47
@@ -83,8 +83,14 @@
 
 #define GIFNAME		"gif"
 
+/*
+ * XXXRW: Note that gif_mtx only protects global gif-related data, not
+ * per-softc data.  See also netinet/in_gif.c for locking needs.
+ */
+static struct mtx gif_mtx;
 static MALLOC_DEFINE(M_GIF, "gif", "Generic Tunnel Interface");
 static LIST_HEAD(, gif_softc) gif_softc_list;
+static int gif_called = 0;
 
 void	(*ng_gif_input_p)(struct ifnet *ifp, struct mbuf **mp, int af);
 void	(*ng_gif_input_orphan_p)(struct ifnet *ifp, struct mbuf *m, int af);
@@ -145,7 +151,9 @@
 
 	gifattach0(sc);
 
+	mtx_lock(&gif_mtx);
 	LIST_INSERT_HEAD(&gif_softc_list, sc, gif_list);
+	mtx_unlock(&gif_mtx);
 	return (0);
 }
 
@@ -173,15 +181,14 @@
 		(*ng_gif_attach_p)(&sc->gif_if);
 }
 
-void
-gif_clone_destroy(ifp)
-	struct ifnet *ifp;
+static void
+gif_destroy(struct gif_softc *sc)
 {
+	struct ifnet *ifp = &sc->gif_if;
 	int err;
-	struct gif_softc *sc = ifp->if_softc;
+
+	gif_delete_tunnel(ifp);
 
-	gif_delete_tunnel(&sc->gif_if);
-	LIST_REMOVE(sc, gif_list);
 #ifdef INET6
 	if (sc->encap_cookie6 != NULL) {
 		err = encap_detach(sc->encap_cookie6);
@@ -203,15 +210,29 @@
 	free(sc, M_GIF);
 }
 
+void
+gif_clone_destroy(ifp)
+	struct ifnet *ifp;
+{
+	struct gif_softc *sc = ifp->if_softc;
+
+	mtx_lock(&gif_mtx);
+	LIST_REMOVE(sc, gif_list);
+	mtx_unlock(&gif_mtx);
+	gif_destroy(sc);
+}
+
 static int
 gifmodevent(mod, type, data)
 	module_t mod;
 	int type;
 	void *data;
 {
+	struct gif_softc *sc;
 
 	switch (type) {
 	case MOD_LOAD:
+		mtx_init(&gif_mtx, "gif_mtx", NULL, MTX_DEF);
 		LIST_INIT(&gif_softc_list);
 		if_clone_attach(&gif_cloner);
 
@@ -223,9 +244,15 @@
 	case MOD_UNLOAD:
 		if_clone_detach(&gif_cloner);
 
-		while (!LIST_EMPTY(&gif_softc_list))
-			gif_clone_destroy(&LIST_FIRST(&gif_softc_list)->gif_if);
-
+		mtx_lock(&gif_mtx);
+		while ((sc = LIST_FIRST(&gif_softc_list)) != NULL) {
+			LIST_REMOVE(sc, gif_list);
+			mtx_unlock(&gif_mtx);
+			gif_destroy(sc);
+			mtx_unlock(&gif_mtx);
+		}
+		mtx_unlock(&gif_mtx);
+		mtx_destroy(&gif_mtx);
 #ifdef INET6
 		ip6_gif_hlim = 0;
 #endif
@@ -314,7 +341,6 @@
 {
 	struct gif_softc *sc = (struct gif_softc*)ifp;
 	int error = 0;
-	static int called = 0;	/* XXX: MUTEX */
 
 #ifdef MAC
 	error = mac_check_ifnet_transmit(ifp, m);
@@ -330,15 +356,22 @@
 	 * XXX: this mechanism may introduce another problem about
 	 *      mutual exclusion of the variable CALLED, especially if we
 	 *      use kernel thread.
+	 * XXXRW: use atomic operations to improve performance.
+	 * XXXRW: This doesn't handle parallel entry into the gif code,
+	 *      since the counter is global and not packet-local.  Use an
+	 *      m_tag?
 	 */
-	if (++called > max_gif_nesting) {
+	mtx_lock(&gif_mtx);
+	if (++gif_called > max_gif_nesting) {
+		mtx_unlock(&gif_mtx);
 		log(LOG_NOTICE,
 		    "gif_output: recursively called too many times(%d)\n",
-		    called);
+		    gif_called);
 		m_freem(m);
 		error = EIO;	/* is there better errno? */
 		goto end;
 	}
+	mtx_unlock(&gif_mtx);
 
 	m->m_flags &= ~(M_BCAST|M_MCAST);
 	if (!(ifp->if_flags & IFF_UP) ||
@@ -378,7 +411,13 @@
 	}
 
   end:
-	called = 0;		/* reset recursion counter */
+	/*
+	 * This is completely bogus.  Shouldn't this be 'gif_called--',
+	 * and this is not MPSAFE.
+	 */
+	mtx_lock(&gif_mtx);
+	gif_called = 0;		/* reset recursion counter */
+	mtx_unlock(&gif_mtx);
 	if (error)
 		ifp->if_oerrors++;
 	return error;
@@ -451,6 +490,9 @@
 }
 
 /* XXX how should we handle IPv6 scope on SIOC[GS]IFPHYADDR? */
+/*
+ * XXXRW: per-gif softc locking required.
+ */
 int
 gif_ioctl(ifp, cmd, data)
 	struct ifnet *ifp;
@@ -688,6 +730,13 @@
 	return error;
 }
 
+/*
+ * XXXRW: There's a general event-ordering issue here: the code to check
+ * if a given tunnel is already present happens before we perform a
+ * potentially blocking setup of the tunnel.  This code needs to be
+ * re-ordered so that the check and replacement can be atomic using
+ * a mutex.
+ */
 int
 gif_set_tunnel(ifp, src, dst)
 	struct ifnet *ifp;
@@ -700,8 +749,10 @@
 	int s;
 	int error = 0; 
 
-	s = splnet();
-
+	/*
+	 * XXXRW: per-gif softc locking required.
+	 */
+	mtx_lock(&gif_mtx);
 	LIST_FOREACH(sc2, &gif_softc_list, gif_list) {
 		if (sc2 == sc)
 			continue;
@@ -721,12 +772,17 @@
 		    bcmp(sc2->gif_pdst, dst, dst->sa_len) == 0 &&
 		    bcmp(sc2->gif_psrc, src, src->sa_len) == 0) {
 			error = EADDRNOTAVAIL;
+			mtx_unlock(&gif_mtx);
 			goto bad;
 		}
 
 		/* XXX both end must be valid? (I mean, not 0.0.0.0) */
 	}
+	mtx_unlock(&gif_mtx);
 
+	/*
+	 * XXXRW: Lock gif softc fields.
+	 */
 	/* XXX we can detach from both, but be polite just in case */
 	if (sc->gif_psrc)
 		switch (sc->gif_psrc->sa_family) {
--- //depot/vendor/freebsd/src/sys/net/if_gre.c	2004/01/30 01:05:29
+++ //depot/user/rwatson/netperf/sys/net/if_gre.c	2004/03/11 22:56:06
@@ -91,6 +91,12 @@
 
 #define GRENAME	"gre"
 
+/*
+ * gre_mtx protects all global variables in if_gre.c.
+ *
+ * XXXRW: It does not protect softc-specific data.
+ */
+struct mtx gre_mtx;
 static MALLOC_DEFINE(M_GRE, GRENAME, "Generic Routing Encapsulation");
 
 struct gre_softc_head gre_softc_list;
@@ -149,6 +155,7 @@
 greattach(void)
 {
 
+	mtx_init(&gre_mtx, "gre_mtx", NULL, MTX_DEF);
 	LIST_INIT(&gre_softc_list);
 	if_clone_attach(&gre_cloner);
 }
@@ -181,24 +188,35 @@
 	sc->wccp_ver = WCCP_V1;
 	if_attach(&sc->sc_if);
 	bpfattach(&sc->sc_if, DLT_NULL, sizeof(u_int32_t));
+	mtx_lock(&gre_mtx);
 	LIST_INSERT_HEAD(&gre_softc_list, sc, sc_list);
+	mtx_unlock(&gre_mtx);
 	return (0);
 }
 
 static void
-gre_clone_destroy(ifp)
-	struct ifnet *ifp;
+gre_destroy(struct gre_softc *sc)
 {
-	struct gre_softc *sc = ifp->if_softc;
 
 #ifdef INET
 	if (sc->encap != NULL)
 		encap_detach(sc->encap);
 #endif
+	bpfdetach(&sc->sc_if);
+	if_detach(&sc->sc_if);
+	free(sc, M_GRE);
+}
+
+static void
+gre_clone_destroy(ifp)
+	struct ifnet *ifp;
+{
+	struct gre_softc *sc = ifp->if_softc;
+
+	mtx_lock(&gre_mtx);
 	LIST_REMOVE(sc, sc_list);
-	bpfdetach(ifp);
-	if_detach(ifp);
-	free(sc, M_GRE);
+	mtx_unlock(&gre_mtx);
+	gre_destroy(sc);
 }
 
 /*
@@ -727,6 +745,7 @@
 static int
 gremodevent(module_t mod, int type, void *data)
 {
+	struct gre_softc *sc;
 
 	switch (type) {
 	case MOD_LOAD:
@@ -735,8 +754,15 @@
 	case MOD_UNLOAD:
 		if_clone_detach(&gre_cloner);
 
-		while (!LIST_EMPTY(&gre_softc_list))
-			gre_clone_destroy(&LIST_FIRST(&gre_softc_list)->sc_if);
+		mtx_lock(&gre_mtx);
+		while ((sc = LIST_FIRST(&gre_softc_list)) != NULL) {
+			LIST_REMOVE(sc, sc_list);
+			mtx_unlock(&gre_mtx);
+			gre_destroy(sc);
+			mtx_lock(&gre_mtx);
+		}
+		mtx_unlock(&gre_mtx);
+		mtx_destroy(&gre_mtx);
 		break;
 	}
 	return 0;
--- //depot/vendor/freebsd/src/sys/net/if_gre.h	2004/01/26 04:35:31
+++ //depot/user/rwatson/netperf/sys/net/if_gre.h	2004/03/11 22:56:06
@@ -54,6 +54,12 @@
 	WCCP_V2
 } wccp_ver_t;
 
+/*
+ * XXXRW: softc fields need locking.
+ *
+ * XXXRW: gre's notion of a 'called' count is not MP-safe, as it assumes
+ * only one packet can be processed at a time.
+ */
 struct gre_softc {
 	struct ifnet sc_if;
 	LIST_ENTRY(gre_softc) sc_list;
@@ -176,6 +182,7 @@
 
 #ifdef _KERNEL
 LIST_HEAD(gre_softc_head, gre_softc);
+extern struct mtx gre_mtx;
 extern struct gre_softc_head gre_softc_list;
 
 u_int16_t	gre_in_cksum(u_int16_t *, u_int);
